/*
 * main.c
 *
 * Created: 07.04.2013 14:49:54
 *  Author: Peter
 */ 
#include "standard.h"
#include "uart.h"
#include "can.h"

#define UART0_BAUD_RATE 9600
#define UART1_BAUD_RATE 19200
#define RUNLED PG0

uint16_t tick=500;
int main (void)
{
	OCR0A = (uint8_t)(int16_t)(F_CPU / 1024 * 10e-4 + 0.5);	// preload for 1ms
	TCCR0A |= (1<<WGM01)|(1<<CS02)|(1<<CS00);			// divide by 1024
	TIMSK0 |= (1<<OCIE0A);				// enable timer Compare A Interrupt
	DDRG |= (1<<RUNLED);
	uart_init( UART_BAUD_SELECT(UART0_BAUD_RATE,F_CPU) ); 
	uart1_init( UART_BAUD_SELECT(UART1_BAUD_RATE,F_CPU) ); 
	sei();
	
	can_init(BITRATE_125_KBPS);
	
	// erzeuge eine Testnachricht
	can_t msg;
	
	msg.id = 0x12;
	msg.flags.rtr = 0;
	msg.length = 4;
	msg.data[0] = 0xde;
	msg.data[1] = 0xad;
	msg.data[2] = 0xbe;
	msg.data[3] = 0xef;
	
	// Nachricht verschicken
	can_send_message(&msg);
	
	while(1)
	{
		
	}
}
ISR(TIMER0_COMP_vect)	//_evry 1ms Interrupt
{
	tick--;
	if (tick==0)
	{
		tick=500;
		PORTG ^=(1<<RUNLED);
		uart_puts("Hallo Peter!\n\r");
		uart1_puts("Hallo Peter von Uart1!\n\r");
	}
}